<script>
  import { scaleLog } from 'd3-scale';
  import { axisBottom } from 'd3-axis';
  import { select, selectAll } from 'd3-selection';
  import { max, min } from 'd3-array';
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 5, right: 5, bottom: 25, left: 25 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  const radius = 10;

  // Array
  const values = [2, 4, 6, 7, 9];

  // Scale
  var myScale = scaleLog()
    .domain([min(values),max(values)])
    .range([0, innerWidth-radius]);
  
  // Axis
  let xAxis = axisBottom(myScale);
  
  let g;
  let transform;
  $: {
    select(g).selectAll("*").remove();
    let axis;
        axis = axisBottom(myScale).tickSizeOuter(0);
        transform = `translate(5, ${innerHeight})`;
    select(g).call(axis);
  }
  
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    <g bind:this={g} {transform}/>
    {#each values as value}
      <circle cx="{myScale(value)+radius/2}" cy="{innerHeight/2}" r="{radius}" fill="teal" />
    {/each}
    <text  x={innerWidth/2} y={innerHeight} text-anchor="middle" fill="currentcolor">x-axis</text>
  </g>
</svg>
